Home | All Classes | Main Classes | Annotated | Grouped Classes | Functions |

# QMotifWidget Class Reference

The QMotifWidget class provides the QWidget API for Xt/Motif widgets. More...

This class is part of the Qt Motif Extension.

`#include <qmotifwidget.h>`

Inherits QWidget.

List of all member functions.

## Public Members

- QMotifWidget ( QWidget * parent, WidgetClass widgetclass, ArgList args = NULL, Cardinal argcount = 0, const char * name = 0, WFlags flags = 0 )
- virtual ~QMotifWidget ()
- Widget motifWidget () const

## Protected Members

- virtual bool x11Event ( XEvent * event )

## Detailed Description

This class is defined in the Qt Motif Extension, which can be found in the `qt/extensions` directory. It is not included in the main Qt API.

The QMotifWidget class provides the QWidget API for Xt/Motif widgets.

QMotifWidget exists to provide a QWidget that can act as a parent for any Xt/Motif widget. Since the QMotifWidget is a proper QWidget, it can be used as a top-level widget (e.g. 0 parent) or as a child of any other QWidget. Note: Since QMotifWidget acts as a parent for Xt/Motif widgets, you should not create QWidgets with a QMotifWidget parent.

An Xt/Motif widget with a top-level QMotifWidget parent can begin using the standard Qt dialogs and custom QDialogs while keeping the main Xt/Motif interface of the application. Using a QMotifWidget as the parent for the various QDialogs will ensure that modality and stacking works properly throughout the entire application.

Applications moving to Qt may have custom Xt/Motif widgets that will take time to rewrite with Qt. Such applications can use these custom widgets as QMotifWidget with QWidget parents. This allows the application's interface to be replaced gradually.

Warning: QMotifWidget uses the X11 window ID of the Motif widget directly, instead of creating its own. Because ot this, QWidget::reparent() will not work. This includes the functions QWidget::showFullScreen() and QWidget::showNormal(), which use QWidget::reparent().

## Member Function Documentation

### QMotifWidget::QMotifWidget ( QWidget * parent, WidgetClass widgetclass, ArgList args = NULL, Cardinal argcount = 0, const char * name = 0, WFlags flags = 0 )

Creates a QMotifWidget of the given widgetclass as a child of parent, with the name name and widget flags flags.

The args and argcount arguments are passed on to XtCreateWidget.

The motifWidget() function returns the resulting Xt/Motif widget. This widget can be used as a parent for any other Xt/Motif widget.

If parent is a QMotifWidget, the Xt/Motif widget is created as a child of the parent's motifWidget(). If \ parent is 0 or a normal QWidget, the Xt/Motif widget is created as a child of a special TopLevelShell widget. Xt/Motif widgets can use this special TopLevelShell parent as the parent for existing Xt/Motif dialogs or QMotifDialogs.

### QMotifWidget::~QMotifWidget ()`[virtual]`

Destroys the QMotifWidget. The special TopLevelShell is also destroyed, if it was created during construction.

### Widget QMotifWidget::motifWidget () const

Returns the embedded Xt/Motif widget. If a Shell widget was created by the constructor, you can access it with XtParent().

This file is part of the Qt toolkit. Copyright © 1995-2007 Trolltech. All Rights Reserved.